/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2020-01-20
 * 参数一共包括 增 删 改 刷新 初始化 保存
 **/
!(function () {
    var Model = BI.inherit(Fix.Model, {
        _init: function () {
            this.service = BI.Services.getService("dec.service.data.set");
        },
        state:function () {
            var self = this;
            return {
                parameters: self.options.value || []
            };
        },
        actions: {
            /**
             * 组件生成时需要初始化参数
             * @param cb
             */
            initParameter:function (cb) {

            },
            /**
             *
             */
            refreshParam: function () {
                var self = this;
                Dec.Utils.getDataSetParameters(this.model.previewedDataSet, function (res) {
                    self.model.parameters = self.service.getParameters(res.data, self.model.parameters);
                });
            },
            addParamter:function(v){
                this.model.parameters.push(v);
            },
            deleteParameter:function(index){
                this.model.parameters.splice(index, 1);
            },
            setParamName: function (index, name) {
                this.model.parameters[index].name = name;
            },
            setParamType: function (index, type) {
                if (this.model.parameters[index].type !== type) {
                    this.model.parameters[index].type = type;
                    this.model.parameters[index].value = this.service.getDefaultValueByType(type);
                    this.model.parameters.splice(0, 0);
                }
            },
            setParamValue: function (index, val) {
                this.model.parameters[index].value = val;
            }
        }
    });
    BI.model("dec.model.data.set.parameter", Model);
})();