!(function () {
    var ExpanderNode = BI.inherit(BI.NodeButton, {

        props: {
            baseCls: "bi-arrow-expander-node bi-list-item cursor-pointer bi-background",
            open: false,
            height: 24
        },

        render: function () {
            var self = this,
                o = this.options;

            return {
                type: "bi.vertical_adapt",
                items: [{
                    el: {
                        type: "bi.arrow.expander.node.checkbox",
                        iconWidth: 16,
                        iconHeight: 16,
                        width: 16,
                        height: o.height,
                        ref: function (ref) {
                            self.checkbox = ref;
                        },
                        handler: function (type) {
                            if (type === BI.Events.CLICK) {
                                self.setSelected(self.isSelected());
                            }
                        }
                    },
                    lgap: 15,
                    rgap: 5
                }, {
                    type: "bi.label",
                    ref: function (ref) {
                        self.text = ref;
                    },
                    textAlign: "left",
                    whiteSpace: "nowrap",
                    textHeight: o.height,
                    height: o.height,
                    hgap: o.hgap,
                    text: o.text,
                    value: o.value,
                    py: o.py
                }]
            };
        },

        setOpened: function (v) {
            ExpanderNode.superclass.setOpened.apply(this, arguments);
            this.checkbox.setSelected(v);
        }
    });
    BI.shortcut("bi.arrow.expander.node", ExpanderNode);
})();