!(function () {
    var expanderIndex = [];
    var ExpandablePanel = BI.inherit(BI.Widget, {
        props: {
            baseCls: "bi-expandable-panel",
            borderGap: 15
        },
        _store: function () {
            return BI.Models.getModel("bi.model.expandable.panel");
        },
        watch: {
            currentExpander: function (v) {
                this._hideOtherExpander(v);
            }
        },
        render: function () {
            var o = this.options;
            return {
                type: "bi.vertical",
                width: o.width,
                height: o.height,
                items: this._createExpanders(o.items)
            };
        },
        _createExpanders: function (items) {
            var expanders = [],
                self = this;
            BI.each(items, function (index, item) {
                expanderIndex.push(index);
                expanders.push({
                    type: "bi.expander",
                    ref: function (_ref) {
                        self[index] = _ref;
                    },
                    listeners: [{
                        eventName: BI.Expander.EVENT_EXPAND,
                        action: function () {
                            self.store.changeExpander(index);
                        }
                    }],
                    el: {
                        type: "bi.arrow.expander.node",
                        height: 28,
                        text: item.text,
                        title: item.text,
                        open:item.open
                    },
                    popup: item.popup
                });
                expanders.push(self._getSplitLine());
            });
            return expanders;
        },
        _getSplitLine: function () {
            var o = this.options;
            return {
                type: "bi.layout",
                cls: "bi-border-bottom split-line",
                height: 1,
                hgap: o.borderGap
            };
        },
        _hideOtherExpander: function (v) {
            var self = this;
            BI.each(expanderIndex, function (index, val) {
                if (v !== val) {
                    self[val].hideView();
                }
            });
        }
    });
    BI.shortcut("bi.expandable_panel", ExpandablePanel);
})();