/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2020-01-16
 **/
!(function () {
    var Factory = BI.inherit(BI.Widget, {
        props: {
            baseCls: "dec-data-set-sql",
            $testId: "dec-data-set-sql",
            value: {
                datasetData: {}
            }
        },
        _store: function () {
            return BI.Models.getModel("dec.model.data.set.type.factory", this.options);
        },
        watch: {
            cacheItems:function(v){
                this.cacheTypeCombo.populate(v);
                this.cacheTypeCombo.setValue(this.model.cacheType);
            },
            cacheTime:function(v){
                this.cacheTimeEditor.setValue(v);
            },
            loaderItems: function(v){
                this.loaderCombo.populate(v);
                this.loaderCombo.setValue(this.model.loaderType);
            },
            loaderConfig: function(v){
                this.loaderEditor.setValue(v);
            },
            resolverItems: function(v){
                this.resolverCombo.populate(v);
                this.resolverCombo.setValue(this.model.resolverType);
            },
            resolverConfig: function (v) {
                this.resolverEditor.setValue(v);
            },
            preprocessorItems: function (v) {
                this.preprocessorCombo.populate(v);
                this.preprocessorCombo.setValue(this.model.preprocessorType);
            },
            preprocessorConfig: function(v){
                this.preprocessorEditor.setValue(v);
            },
            formatterItems:function(v){
                this.formatterCombo.populate(v);
                this.formatterCombo.setValue(this.model.formatterType);
            },
            formatterConfig: function(v){
              this.formatterEditor.setValue(v);  
            },
            filterItems: function(v){
                this.filterCombo.populate(v);
                this.filterCombo.setValue(this.model.filterType);
            },
            filterConfig: function(v){
              this.filterEditor.setValue(v);  
            },
            "resolverType || resolverConfig || loaderConfig || loaderType || preprocessorConfig || preprocessorType || formatterConfig || formatterType || filterConfig || filterType parameters.**": function () {
                this.previewPane.resetPreview();
            },
            parameters: function () {
                this.paramSettingPane.populate(this.model.paramItems, this.model.paramHeader);
            }
        },
        beforeInit: function (cb) {
            this.store.initPage(cb);
        },
        mounted:function(){

        },
        _getLoaderPanel: function(){
            var self = this;
            return {
                type: "bi.vtape",
                height:400,
                items: [{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        title: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        textAlign: "left",
                        width: 50
                    }, {
                        type: "bi.text_value_check_combo",
                        width: 360,
                        items: this.model.loaderItems,
                        value: this.model.loaderType,
                        listeners: [{
                            eventName: BI.TextValueCheckCombo.EVENT_CHANGE,
                            action: function () {
                                self.store.setLoaderType(this.getValue()[0]);
                            }
                        }],
                        ref: function (_ref) {
                            self.loaderCombo = _ref;
                        }
                    }]
                },{
                    type: "bi.textarea_editor",
                    cls: "bi-border",
                    value: this.model.loaderConfig,
                    ref: function (_ref) {
                        self.loaderEditor = _ref;
                    },
                    listeners: [{
                        eventName: BI.FormulaEditor.EVENT_CHANGE,
                        action: function () {
                            self.store.setLoaderConfig(this.getValue());
                        }
                    }]
                }]
            };
        },
        _getResolverPanel: function(){
            var self = this;
            return {
                type: "bi.vtape",
                height:400,
                items: [{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        title: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        textAlign: "left",
                        width: 50
                    }, {
                        type: "bi.text_value_check_combo",
                        width: 360,
                        items: this.model.resolverItems,
                        value: this.model.resolverType,
                        listeners: [{
                            eventName: BI.TextValueCheckCombo.EVENT_CHANGE,
                            action: function () {
                                self.store.setResolverType(this.getValue()[0]);
                            }
                        }],
                        ref: function (_ref) {
                            self.resolverCombo = _ref;
                        }
                    }]
                },{
                    type: "bi.textarea_editor",
                    cls: "bi-border",
                    value: this.model.resolverConfig,
                    ref: function (_ref) {
                        self.resolverEditor = _ref;
                    },
                    listeners: [{
                        eventName: BI.FormulaEditor.EVENT_CHANGE,
                        action: function () {
                            self.store.setResolverConfig(this.getValue());
                        }
                    }]
                }]
            };
        },
        _getPreprocessorPanel: function(){
            var self = this;
            return {
                type: "bi.vtape",
                height:400,
                items: [{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        title: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        textAlign: "left",
                        width: 50
                    }, {
                        type: "bi.text_value_check_combo",
                        width: 360,
                        items: this.model.preprocessorItems,
                        value: this.model.preprocessorType,
                        listeners: [{
                            eventName: BI.TextValueCheckCombo.EVENT_CHANGE,
                            action: function () {
                                self.store.setPreprocessorType(this.getValue()[0]);
                            }
                        }],
                        ref: function (_ref) {
                            self.preprocessorCombo = _ref;
                        }
                    }]
                },{
                    type: "bi.textarea_editor",
                    cls: "bi-border",
                    value: this.model.preprocessorConfig,
                    ref: function (_ref) {
                        self.preprocessorEditor = _ref;
                    },
                    listeners: [{
                        eventName: BI.FormulaEditor.EVENT_CHANGE,
                        action: function () {
                            self.store.setPreprocessorConfig(this.getValue());
                        }
                    }]
                }]
            };
        },
        _getFilterPanel: function(){
            var self = this;
            return {
                type: "bi.vtape",
                height:400,
                items: [{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        title: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        textAlign: "left",
                        width: 50
                    }, {
                        type: "bi.text_value_check_combo",
                        width: 360,
                        items: this.model.filterItems,
                        value: this.model.filterType,
                        listeners: [{
                            eventName: BI.TextValueCheckCombo.EVENT_CHANGE,
                            action: function () {
                                self.store.setFilterType(this.getValue()[0]);
                            }
                        }],
                        ref: function (_ref) {
                            self.filterCombo = _ref;
                        }
                    }]
                },{
                    type: "bi.textarea_editor",
                    cls: "bi-border",
                    value: this.model.filterConfig,
                    ref: function (_ref) {
                        self.filterEditor = _ref;
                    },
                    listeners: [{
                        eventName: BI.FormulaEditor.EVENT_CHANGE,
                        action: function () {
                            self.store.setFilterConfig(this.getValue());
                        }
                    }]
                }]
            };
        },
        _getFormatterPanel: function(){
            var self = this;
            return {
                type: "bi.vtape",
                height:400,
                items: [{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        title: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        textAlign: "left",
                        width: 50
                    }, {
                        type: "bi.text_value_check_combo",
                        width: 360,
                        items: this.model.formatterItems,
                        value: this.model.formatterType,
                        listeners: [{
                            eventName: BI.TextValueCheckCombo.EVENT_CHANGE,
                            action: function () {
                                self.store.setFormatterType(this.getValue()[0]);
                            }
                        }],
                        ref: function (_ref) {
                            self.formatterCombo = _ref;
                        }
                    }]
                },{
                    type: "bi.textarea_editor",
                    cls: "bi-border",
                    value: this.model.formatterConfig,
                    ref: function (_ref) {
                        self.formatterEditor = _ref;
                    },
                    listeners: [{
                        eventName: BI.FormulaEditor.EVENT_CHANGE,
                        action: function () {
                            self.store.setFormatterConfig(this.getValue());
                        }
                    }]
                }]
            };
        },
        render: function () {
            var self = this;
            var preprocessor = self._getPreprocessorPanel();
            var loader = self._getLoaderPanel();
            var formatter = self._getFormatterPanel();
            var resolver = self._getResolverPanel();
            var filter = self._getFilterPanel();
            return {
                type: "bi.htape",
                items: [{
                    el: {
                        type: "bi.vtape",
                        items: [

                            {
                                type: "bi.expandable_panel",
                                items: [
                                    {
                                        text: BI.i18nText("Plugin-Dec-Data_Set_Preprocessor"),
                                        popup: preprocessor
                                    },{
                                        text: BI.i18nText("Plugin-Dec-Data_Set_Loader"),
                                        open:true,
                                        popup: loader
                                    },{
                                        text: BI.i18nText("Plugin-Dec-Data_Set_Formatter"),
                                        popup: formatter
                                    },{
                                        text: BI.i18nText("Plugin-Dec-Data_Set_Resolver"),
                                        popup: resolver
                                    },
                                    {
                                        text: BI.i18nText("Plugin-Dec-Data_Set_Filter"),
                                        popup: filter
                                    }
                                ]
                            },
                            {
                                type: "bi.vertical_adapt",
                                cls:"bi-sortable-holder",
                                height:24,
                                items:[{
                                    type: "bi.label",
                                    cls: "dec-font-weight-bold",
                                    text: BI.i18nText("Plugin-Dec-Data_Set_Cache_Type")+":",//
                                    title: BI.i18nText("Plugin-Dec-Data_Set_Cache_Type"),
                                    textAlign: "left",
                                    width: 50
                                },{
                                    type: "bi.text_value_check_combo",
                                    width: 60,
                                    items: this.model.cacheItems,
                                    value: this.model.cacheType,
                                    listeners: [{
                                        eventName: BI.TextValueCheckCombo.EVENT_CHANGE,
                                        action: function () {
                                            self.store.setCacheType(this.getValue()[0]);
                                        }
                                    }],
                                    ref: function () {
                                        self.cacheTypeCombo = this;
                                    }
                                },{
                                    type: "bi.text_editor",
                                    width: 40,
                                    errorText: BI.i18nText("Plugin-Dec-Data_Set_Cache_Number_Error"),
                                    value: this.model.cacheTime,
                                    allowBlank: false,
                                    validationChecker: function(v) {
                                        if (/^[0-9]+$/.test(v)) {
                                            return true;
                                        }
                                        return false;
                                    },
                                    listeners: [{
                                        eventName: BI.FormulaEditor.EVENT_CHANGE,
                                        action: function () {
                                            self.store.setCacheTime(this.getValue());
                                        }
                                    }],
                                    ref: function () {
                                        self.cacheTimeEditor = this;
                                    }
                                },{
                                    type: "bi.label",
                                    cls: "dec-font-weight-bold",
                                    text: BI.i18nText("Plugin-Dec-Data_Set_Cache_Minute"),
                                    title: BI.i18nText("Plugin-Dec-Data_Set_Cache_Minute"),
                                    textAlign: "left",
                                    width: 50
                                }]
                            },
                            {
                                type: "bi.vtape",
                                height: 296,
                                tgap: 10,
                                items: [{
                                    type: "bi.left_right_vertical_adapt",
                                    height: 24,
                                    items: {
                                        left: [{
                                            type: "bi.label",
                                            cls: "dec-font-weight-bold",
                                            text: BI.i18nText("Dec-Basic_Parameter_Setting")
                                        }],
                                        right: [{
                                            type: "bi.icon_button",
                                            cls: "add-keyword-font",
                                            level: "ignore",
                                            lgap: 10,
                                            handler: function () {
                                                self.store.addParamter({
                                                    type:"String",
                                                    name:"",
                                                    value:""});
                                            }
                                        },{
                                            type: "bi.icon_button",
                                            cls: "refresh-font",
                                            lgap: 10,
                                            level: "ignore",
                                            handler: function () {
                                                self.store.refreshParam();
                                            }
                                        }]
                                    }
                                }, {
                                    type: "bi.components.style_table",
                                    cls: "param-table factory-param",
                                    width: 420,
                                    columnSize: [100, 120, 150,""],
                                    items: this.model.paramItems,
                                    header: this.model.paramHeader,
                                    ref: function () {
                                        self.paramSettingPane = this;
                                    }
                                }]
                            }
                        ]
                    },
                    width: 400,
                    lgap: 10,
                    vgap: 15
                },
                    {
                        el: {
                            type: "bi.absolute",
                            cls: "bi-sortable-holder",
                            items: [{
                                el: {
                                    type: "dec.data.set.preview",
                                    listeners: [{
                                        eventName: "EVENT_CHANGE",
                                        action: function () {
                                            self.store.refreshParam();
                                            self.previewPane.previewData();
                                        }
                                    }],
                                    ref: function (_ref) {
                                        self.previewPane = _ref;
                                    }
                                }, top: 10, right: 10, bottom: 10, left: 10
                            }]
                        },
                        hgap: 10,
                        vgap: 15
                    }
                ]
            };
        },
        getValue: function () {
            return {
                preprocessorType: this.model.preprocessorType,
                preprocessorConfig: this.model.preprocessorConfig,
                loaderType: this.model.loaderType,
                loaderConfig: this.model.loaderConfig,
                formatterType: this.model.formatterType,
                formatterConfig: this.model.formatterConfig,
                resolverType: this.model.resolverType,
                resolverConfig: this.model.resolverConfig,
                filterType: this.model.filterType,
                filterConfig: this.model.filterConfig,
                cacheType:this.model.cacheType,
                cacheTime:this.model.cacheTime,
                parameters: this.model.parameters
            };
        }
    });
    BI.shortcut("dec.data.set.type.factory", Factory);
})();